angular.module('starter.controllers')
  .controller('graphsCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state, $ionicSlideBoxDelegate, $q, graphService, $log) {
    $scope.name = '';
    $scope.slidesArray = [];
    $scope.graphCount = 0;
    $scope.graph = [];
    $scope.graph[0] = [];
    $scope.graph[1] = [];
    var totalPiPoGraph = [];
    var desc = '';
    var txt = 'File not Transferred Yet';
    $('svg').children().css('fill', '#ffffff');
    $scope.reloadGraph = function() {
      $state.reload();
    }
    $scope.$on('$ionicView.enter', function(e) {
      $('#mainmenuid').hide();
      $scope.$parent.$parent.inDetailpage = true;
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Business Metrics';
      $scope.slides = [];
	  $scope.selectedSlide = 0;
      var graphsArray = [];
        var color;
       
        $scope.slideChanged = function(index) { 
     
       $( ".highcharts-menu-0" ).css('display','none');   
       $(".highcharts-button-box").css('fill','#ffffff');
       
          };
      //added
      graphsPromise.startService('graphSetup.json', $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion).then(function(graphArraySetup) {
        var graphs = {};
        angular.forEach(graphArraySetup, function(graph) {
          if (graph.graphName == $stateParams.graphName) {
            graphs = graph;
          }
        });
        $scope.$parent.$parent.currentTeamName = graphs.title;
        $scope.createSlides(graphs.setup);
        angular.forEach(graphs.slides, function(slide) {
          var startDiv = 1;
          angular.forEach(slide.graphsToRead, function(graphSet, i) {
            graphService.startService(graphSet, $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion).then(function(response) {
              angular.forEach(slide.labels, function(graphTitle, graphKey) {
                  desc = slide.description;
                //  console.log("description ::"+slide.description);
                var seriesArray = $scope.parseSeriesArray(slide, response, graphTitle, graphKey);
                $scope.renderGraph(slide, {
                  title: {
                    'text': graphTitle
                  }
                }, seriesArray);
                startDiv++;
              });
			  //alert($stateParams.slideNum);
			  $scope.selectedSlide = $stateParams.slideNum;
			  //alert($scope.selectedSlide);
			  
            });
          });
        });
		
      });
	  
	  
	  
    });
    $scope.createSlides = function(setup) {
      for (var i = 1; i <= setup.numberOfSlides; i++) {
        var slideSetup = {
          'id': '',
          'div': []
        };
        slideSetup.id = 'slide' + i;
        for (var j = 1; j <= setup.numberofDivs; j++) {
          slideSetup.div.push('resultDiv' + j);
        }
        $scope.slides.push(slideSetup);
      }
      $ionicSlideBoxDelegate.update();
    };
    $scope.parseSeriesArray = function(slide, seriesArray, graphTitle, graphKey) {
      var series = [];
      var d = new Date();
      if(slide.graphType == 'horizontalBarGraph'){
        slide.options.xAxis = {
          "type" : "category"
        };
        slide.options.legend= {
        "enabled": false
    		};
        series = [];
        angular.forEach(seriesArray, function(graphSeries,index) {
          series[index] = {
            "name": slide.categories[index],
            "data": [],
            'type': slide.types[index],
            'data': [],
            'color': slide.colors[index],
          };
          angular.forEach(graphSeries, function(data) {
            series[index].data.push([slide.categories[index],parseInt(data[slide.fieldToRead])]);
          });
        });
      }
      if (slide.graphType == 'lineGraph2Files' || slide.graphType == 'lineGraph2FilesCCAR') {
        series[0] = {
          'name': slide.names[0],
          'type': slide.types[0],
          'data': [],
          'lineWidth': 2,
          'color': slide.colors[0],
          'zIndex': slide.zIndex[0],
        };
        series[1] = {
          'name': slide.names[1],
          'type': slide.types[1],
          'data': [],
          'lineWidth': 2,
          'color': slide.colors[1],
          'zIndex': slide.zIndex[1],
        };
          var cnt= 0;
          
           $scope.today = [];
           $scope.weekAgo = [];
          
        angular.forEach(seriesArray, function(graphSeries, i) {
          angular.forEach(graphSeries, function(data) {
            if (data[1] == graphKey && slide.graphType == 'lineGraph2Files') {
                //console.log("data ::"+data);
              var hourmin = data[0].split(':');
              series[i].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), parseInt(hourmin[0]), parseInt(hourmin[1])), parseInt(data[2])]);
                
                if(cnt == 0)
                {
                   $scope.today.push(data[2]);
                }
                else
                {
                   $scope.weekAgo.push(data[2]); 
                }
            }
            if (data[1] == graphKey && slide.graphType == 'lineGraph2FilesCCAR') {
              var parsedData = data[0].replace(' ', '-').replace(':', '-').split('-');
              var year = parseInt(parsedData[0]);
              var month = parseInt(parsedData[1]) - 1;
              var day = parseInt(parsedData[2]);
              var hour = parseInt(parsedData[3]);
              var min = parseInt(parsedData[4]);
              var hourmin = data[0].split(':');
              series[i].data.push([Date.UTC(year, month, day, hour, min), parseInt(data[2])]);
            }
          });
            
            cnt++;
        });
          
          // code for color status icon
          
          $scope.percentage50 = 50;
          $scope.percentage25 = 25;
          
          var todayLastVal = $scope.today[$scope.today.length - 1]; 
        
          var index = $scope.today.lastIndexOf(todayLastVal);
          
          var weekAgoVal = $scope.weekAgo[index];
          
          var percentage =((todayLastVal-weekAgoVal)/todayLastVal)*100;          
                  
          if(percentage < 0)
          {
              percentage = Math.abs(percentage);
              
              if(percentage>=$scope.percentage50)
              {
                      
                      color="Red";
                   //   console.log("val::"+todayLastVal+ " "+weekAgoVal+ " "+ percentage+ " "+color);
              }
              else if(percentage<$scope.percentage50 && percentage>=$scope.percentage25 )
              {
                   
                      color="orange";
                    //  console.log("val::"+todayLastVal+ " "+weekAgoVal+ " "+ percentage+ " "+color);
              }
              else
              {
                   color ="black";
                 //  console.log("val::"+todayLastVal+ " "+weekAgoVal+ " "+ percentage+ " "+color);
              }
           }
          else{
                   color ="black";
                 //  console.log("% is positive :: val::"+todayLastVal+ " "+weekAgoVal+ " "+ percentage+ " "+color);
          }
        
     }
      if (slide.graphType == 'lineGraph1File') {
        series = [];
        angular.forEach(slide.categories, function(category, i) {
          series[i] = {
            "name": category,
            "data": []
          };
          angular.forEach(seriesArray, function(graphSeries) {
            angular.forEach(graphSeries, function(data) {
              if (data[1].replace(/ /g, '') == category) {
                if (data[0].length > 5) {
                  var parsedData = data[0].replace('/', '-').replace('/', '-').replace(' ', '-').replace(':', '-').split('-');
                  var year = parseInt(parsedData[0]);
                  var month = parseInt(parsedData[1]) - 1;
                  var day = parseInt(parsedData[2]);
                  var hour = parseInt(parsedData[3]);
                  var min = parseInt(parsedData[4]);
                  series[i].data.push([Date.UTC(year, month, day, hour, min), parseInt(data[parseInt(slide.fieldToRead)])]);
                } else {
                  var hourmin = data[0].split(':');
                  series[i].data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), parseInt(hourmin[0]), parseInt(hourmin[1])), parseInt(data[parseInt(slide.fieldToRead)])]);
                }
              }
            });
          });
        });
        if (slide.removeEmptySeries == true) {
          var seriesFiltered = [];
          angular.forEach(series, function(row) {
            if (row.data.length > 0) {
              seriesFiltered.push(row);
            }
          });
          return seriesFiltered;
        }
      }
      if (slide.graphType == 'columnGraph') {
        series = [];
        angular.forEach(seriesArray, function(graphSeries, i) {
          series[i] = {
            "name": slide.seriesLabels[i],
            'type': 'column',
            "data": []
          };
          angular.forEach(graphSeries, function(data) {
            series[i].data.push(parseInt(data[1]));
            slide.columnHour = data[0].slice(-2);
          });
        });
      }
      if (slide.graphType == 'lineGraph1FileToday') {
        series = [];
        angular.forEach(slide.categories, function(category, i) {
          series[i] = {
            "name": category,
            "data": []
          };
          angular.forEach(seriesArray, function(graphSeries) {
            angular.forEach(graphSeries, function(data) {
              var parsedData = data[0].split('-');
              var year = parseInt(parsedData[0]);
              var month = parseInt(parsedData[1]) - 1;
              var day = parseInt(parsedData[2]);
              if (data[1].replace(/ /g, '') == category && month == d.getMonth() && day == d.getDate()) {
                series[i].data.push([Date.UTC(year, month, day, 0, 0), parseInt(data[parseInt(slide.fieldToRead)])]);
              }
            });
          });
        });
      }
      if (slide.graphType == 'barLineGraph2Files') {
        var series = [];
        var categoryPosition = 0;
        angular.forEach(seriesArray, function(graphSeries, i) {
          series[i + categoryPosition] = {
            'name': slide.categories[i + categoryPosition],
            'type': categoryPosition == 0 ? 'column' : 'spline',
            'data': [],
          };
          series[i + categoryPosition + 1] = {
            'name': slide.categories[i + categoryPosition + 1],
            'type': categoryPosition == 0 ? 'column' : 'spline',
            'data': [],
          };
          if (categoryPosition != 0) {
            series[i + categoryPosition].marker = {
              'enabled': false
            };
            series[i + categoryPosition].dashStyle = 'line';
            series[i + categoryPosition].tooltip = {
              'valueSuffix': ' $'
            };
            series[i + categoryPosition + 1].marker = {
              'enabled': false
            };
            series[i + categoryPosition + 1].dashStyle = 'line';
            series[i + categoryPosition + 1].tooltip = {
              'valueSuffix': ' $'
            };
          }
          angular.forEach(graphSeries, function(data) {
            if (data[1] == graphKey) {
              var parsedData = data[0].split('-');
              var year = parseInt(parsedData[0]);
              var month = parseInt(parsedData[1]) - 1;
              var day = parseInt(parsedData[2]);
              series[i + categoryPosition].data.push([Date.UTC(year, month, day, 0, 0), parseInt(data[2])]);
              series[i + categoryPosition + 1].data.push([Date.UTC(year, month, day, 0, 0), parseInt(data[3])]);
            }
          });
          categoryPosition += 1;
        });
      }
      if (slide.graphType == 'categoryGraphs2Files') {
        var series = [];
        var categoryPosition = 0;
        angular.forEach(slide.categories,function(category,categoryId){
          series[categoryId] = {
            'name': slide.categories[categoryId],
            'type': 'column',
            'data': [],
            // 'stack' : 'today',
          };
        });
        angular.forEach(seriesArray, function(graphSeries, i) {
          angular.forEach(graphSeries,function(data){
            angular.forEach(series,function(row){
              if(row.name == data[1]){
                var hourmin = data[0].split(':');
                // row.stack = i == 0 ? 'today' : 'weekago';
                row.type = slide.types[i];
                row.data.push([Date.UTC(d.getFullYear(), d.getMonth(), d.getDate(), parseInt(hourmin[0]), parseInt(hourmin[1])), parseInt(data[2])]);
              }
            });
          });
        });
        categoryPosition += 1;
      }
      if (slide.removeEmptySeries == true) {
        var seriesFiltered = [];
        angular.forEach(series, function(row) {
          if (row.data.length > 0) {
            seriesFiltered.push(row);
          }
        });
        return seriesFiltered;
      }
      return series;
    };
    $scope.renderGraph = function(slide, graphOptions, seriesArray) {
      var graphBasicSetup = {};
      graphBasicSetup.chart = {
        'zoomType': 'xy'
      };
      graphBasicSetup.credits = {
        'enabled': false,
        'text': 'Advanced Technologies and Automation',
        'href': 'http://amdocspsg.neocities.com/'
      };
      graphBasicSetup.title = {
        'text': ''
      };
      graphBasicSetup.subtitle = {
        'text': ''
      };
      graphBasicSetup.plotOptions = {
        'series': {
          'marker': {
            'enabled': false
          }
        }
      };
      graphBasicSetup.xAxis = {};
      graphBasicSetup.yAxis = {
        'title': {
          'text': null
        },
        'min': 0
      };
      graphBasicSetup.tooltip = {
        'shared': true
      };
     
      graphBasicSetup.exporting = {
          menuItemDefinitions: {
            
            message: {
                
                text: desc
                
            }
               
            },
           
        
         'buttons': {
            'myButton': 
                 {
                             'symbol': 'url(https://amdocspsg.neocities.org/bm_images/info.png)',
                             'symbolSize': 22,
                             '_titleKey': 'printChart',
                             'verticalAlign': 'top',
                             'align':'right',
                              menuItems: ['message'],
                             'symbolX' : 25,
                              symbolY: 19
                 },
 
         	'contextButton': {
         		'enabled': false
         		},
         	colorButton: 
         	{
         		'symbol': 'circle' ,
                'symbolFill': color,
                'align':'left',
                'verticalAlign': 'top',
                'symbolStrokeWidth':0,
                'symbolX' : 40,
                'symbolSize': 20
               
         	}
      }
    };  
      graphBasicSetup.series = seriesArray;

      graphBasicSetup.legend = {};
      if (slide.graphType == 'barLineGraph2Files') {
        graphBasicSetup.xAxis.type = 'datetime'
        graphBasicSetup.xAxis.dateTimeLabelFormats = { // don't display the dummy year
          month: '%e. %b',
          year: '%b'
        };
      }
      if (slide.graphType == 'lineGraph2Files' ||
        slide.graphType == 'lineGraph1File' ||
        slide.graphType == 'lineGraph2FilesCCAR' ||
        slide.graphType == 'lineGraph1FileToday') {
        var d = new Date();
        graphBasicSetup.chart.type = slide.graphType == 'lineGraph1FileToday' ? 'column' : 'spline';
        graphBasicSetup.xAxis = {
          'type': 'datetime',
          'tickInterval': 3600 * 1000 / 1,
          'labels': {
            'format': '{value:%H:%M}',
            'rotation': -90
          },
          'dateTimeLabelFormats': {
            'hour': '%H:%M',
          }
        };
      }
      graphBasicSetup = Object.assign(graphBasicSetup, slide.options, graphOptions);
      if (slide.graphType == 'columnGraph') {
        graphBasicSetup.title.text = graphBasicSetup.title.text.replace('xxx', slide.columnHour);
        graphBasicSetup.xAxis.categories = slide.categories;
        graphBasicSetup.xAxis.crosshair = true;
      }
      $log.log(graphBasicSetup);
      $('#slide' + slide.startSlide + ' #resultDiv' + slide.targetDiv).highcharts(graphBasicSetup);
    };
  })
