angular.module('starter.controllers')
  .controller('psgBulletinStaticCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, getImagePromise, $state) {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = 'PSG Bulletin';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/psg_bulletin/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'psg_bulletin', path, $scope.appVersion);
      $scope.images = [];
      //var testImages = [];
      imageService.then(
        function(success) {
          angular.forEach(success.listOfImages, function(imageInfo) {
            var image = JSON.parse(imageInfo);
            //testImages.push(JSON.parse(imageInfo));
            $scope.images.push(image.imageUri);
            // var found = false;
            // angular.forEach($scope.images, function(imageinA) {
            //   if (imageinA == image.imageUri) {
            //     found = true;
            //   }
            // });
            // if (!found) {
            //   // $scope.images.push(image.imageUri);
            // }
          });
          $scope.$parent.$parent.currentImageURL = $scope.images[0];
          $ionicSlideBoxDelegate.update();
        },
        function(error) {
          alert("got error in images");
        }
      );
    });
  })
  
  .controller('deploymentStatusStaticCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, getImagePromise, $state) {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = '1802 Deployment';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/deployment_status/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'deployment_status', path, $scope.appVersion);
      $scope.images = [];
      //var testImages = [];
      imageService.then(
        function(success) {
          angular.forEach(success.listOfImages, function(imageInfo) {
            var image = JSON.parse(imageInfo);
            //testImages.push(JSON.parse(imageInfo));
            $scope.images.push(image.imageUri);
            // var found = false;
            // angular.forEach($scope.images, function(imageinA) {
            //   if (imageinA == image.imageUri) {
            //     found = true;
            //   }
            // });
            // if (!found) {
            //   // $scope.images.push(image.imageUri);
            // }
          });
          $scope.$parent.$parent.currentImageURL = $scope.images[0];
          $ionicSlideBoxDelegate.update();
        },
        function(error) {
          alert("got error in images");
        }
      );
    });
  })
  
  /*.controller('dtvDashCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, $state) {
    $('#mainmenuid').show();
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.heightLandscapeModal = {
      height: '-webkit-fill-available',
      width: 'unset'
    };
    $scope.$on('$ionicView.enter', function(e) {
      $scope.refreshImages = function() {
        $state.reload();
      }
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      $scope.styleSlider = {};
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      var url = 'https://dtvdashboard.neocities.org/images/';
      $scope.slideHasChanged = function(index) {
        //alert(index);
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
        //alert($scope.$parent.$parent.currentImageURL);
      }
      $scope.images = [];
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = 'DTV Dashboard';
      $scope.images.push(url + '01.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '02.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '03.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '04.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '05.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '06.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '07.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '08.jpg' + '?' + new Date().getTime());
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $ionicSlideBoxDelegate.update();
    });
  })
  .controller('dynamicDashCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, $state) {
    $('#mainmenuid').show();
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.heightLandscapeModal = {
      height: '-webkit-fill-available',
      width: 'unset'
    };
    $scope.$on('$ionicView.enter', function(e) {
      $scope.refreshImages = function() {
        $state.reload();
      }
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      $scope.styleSlider = {};
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      var url = 'https://psgfridayflash.neocities.org/images/';
      $scope.imageSrc = url + '01.jpg';
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }

      $scope.slideHasChanged = function(index) {
        //alert(index);
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
        //alert($scope.$parent.$parent.currentImageURL);
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = 'PSG Friday Flash';
      $scope.images = [];
      $scope.images.push(url + '01.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '02.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '03.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '04.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '05.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '06.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '07.jpg' + '?' + new Date().getTime());
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $ionicSlideBoxDelegate.update();
    });
  })*/
  .controller('iphoneReportsStaticCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, $state) {
    $('#mainmenuid').show();
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.heightLandscapeModal = {
      height: '-webkit-fill-available',
      width: 'unset'
    };
    $scope.$on('$ionicView.enter', function(e) {
      $scope.refreshImages = function() {
        $state.reload();
      }
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      var url = 'https://iphonereports.neocities.org/images/';
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }

      $scope.slideHasChanged = function(index) {
        //alert(index);
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
        //alert($scope.$parent.$parent.currentImageURL);
      }
      $scope.imageSrc = '';
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = 'Perf Stats';
      $scope.images = [];
      $scope.images.push(url + '01.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '02.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '03.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '04.jpg' + '?' + new Date().getTime());
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      $ionicSlideBoxDelegate.update();
    });
  })
  /*.controller('mgmtReportsCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, $state) {
    $('#mainmenuid').show();
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.heightLandscapeModal = {
      height: '-webkit-fill-available',
      width: 'unset'
    };
    $scope.$on('$ionicView.enter', function(e) {
      $scope.refreshImages = function() {
        $state.reload();
      }
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      var url = 'https://mgmtreports.neocities.org/images/';
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }

      $scope.slideHasChanged = function(index) {
        //alert(index);
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
        //alert($scope.$parent.$parent.currentImageURL);
      }
      $scope.imageSrc = '';
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.currentTeamName = 'Mgmt. Reports';
      $scope.images = [];
      $scope.images.push(url + '01.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '02.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '03.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '04.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '05.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '06.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '07.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '08.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '09.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '10.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '11.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '12.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '13.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '14.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '15.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '16.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '17.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '18.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '19.jpg' + '?' + new Date().getTime());
      $scope.images.push(url + '20.jpg' + '?' + new Date().getTime());
      //$scope.images.push(url + '03.jpg' + '?' + new Date().getTime());
      //$scope.images.push(url + '04.jpg' + '?' + new Date().getTime());
      $scope.$parent.$parent.currentImageURL = $scope.images[0];

      $ionicSlideBoxDelegate.update();
    });
  })*/
  .controller('imageCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, getImagePromise, $state) {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
        
      var menuid = $stateParams.menuid;
      var path = $stateParams.imagepath.replace(/:/g,'/');
      $scope.$parent.$parent.currentTeamName = $stateParams.pageHeading;
      
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, menuid, path, $scope.appVersion);
      $scope.images = [];
      imageService.then(
        function(success) {
          angular.forEach(success.listOfImages, function(imageInfo) {
            var image = JSON.parse(imageInfo);
            $scope.images.push(image.imageUri);
          });
          $scope.$parent.$parent.currentImageURL = $scope.images[0];
          $ionicSlideBoxDelegate.update();
        },
        function(error) {
          alert("Getting Error while fetching the images :" +error);
        }
      );
    });
  })
