angular.module('starter.controllers')
  .controller('summaryCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicLoading, $ionicSlideBoxDelegate, loginPromise, aclPromise, teamDataPromise, $state,countDataPromise,headsUpCountPromise, $interval) {
    $scope.$on('$ionicView.enter', function(e) {

      $ionicLoading.show();
      $('#mainmenuid').show();
      $scope.$parent.$parent.inDetailpage = false;
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Home';

      $scope.resultData = $scope.$parent.$parent.resultData;
      $scope.urlData = $scope.$parent.$parent.urlData;

      $scope.getSummaryData = function(){
        // This object will hold the list of items to be shown on the screen
        $scope.summaryData = [];

        // Initializing an array for holding the counts of P0 and Perfs
        var pCounts = [];
        pCounts[0] = {
                      'name': 'P0 Alerts',
                      'numberOfAlerts': 0,
                      'url': ''
                    }; // p0
        pCounts[1] = {
                      'name': 'Perf Alerts',
                      'numberOfAlerts': 0,
                      'url': ''
                    }; // perf
					
		pCounts[2] = {
                      'name': 'Heads Up',
                      'numberOfAlerts': 0,
                      'url': ''
                    };

        // Calling the alert count webservice via the promise
        $scope.alertCounts = countDataPromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
		
		
		  
        $scope.alertCounts.then(function(countArray) {

		  
		 $scope.headsUpCounts = headsUpCountPromise.startService($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');

         
		
		   
		  $scope.headsUpCounts.then(function(response) {
			  
			   // Aggregating the counts for P0 and Perfs
            angular.forEach(countArray,function(count) {
            if(count.priority.toLowerCase() != 'p0') {
              pCounts[1].numberOfAlerts += parseInt(count.openAlertsCount);
            }
            else if(count.priority.toLowerCase() == 'p0') {
              pCounts[0].numberOfAlerts += parseInt(count.openAlertsCount);
            }
          });
		  
		  
		  pCounts[2].numberOfAlerts = response.count;
         
		 
		 //Adding all the Menu items to the summaryData object
		 angular.forEach($scope.$parent.$parent.urlData, function(urlInfo) {
			  
            if (urlInfo.alias != 'Home') { // Don't need to add Home
              var listItem = {
                'name': '',
                'numberOfAlerts': '',
                'url': '',
                'level': '',
                'icon':''
              };

              listItem.name = urlInfo.alias;
              listItem.url = urlInfo.url;
              listItem.icon = urlInfo.icon;
              listItem.level = urlInfo.level;
              // Checking if the item is Perf or P0. In which case, setting the alert number
              angular.forEach(pCounts, function(count){
                if (count.name == urlInfo.alias) {
					
                  listItem.numberOfAlerts = parseInt(count.numberOfAlerts);
                }
              });

              $scope.summaryData.push(listItem);
            }
          });
		  // Done adding all items to the summaryData object
		  $ionicLoading.hide();
          $scope.$broadcast('scroll.refreshComplete');
		  
		  });
		 
		 
          

          
        },function(errorMessage){
          $ionicLoading.hide();
          $scope.$broadcast('scroll.refreshComplete');
          window.localStorage['current_page'] = 'home_screen';
          $scope.$parent.$parent.doLogin();
        });
      };

      if (Object.keys($scope.summaryData).length != 0) {
        //There is data already, so won't load again until user refreshes
        $ionicLoading.hide();
      }
      else {
        //There is no data, so it is the first time
        $scope.getSummaryData();
      }

      $interval(function () {
        $scope.alertCount();
      }, 1000 * 60 * 60);
    });
  })
