angular.module('starter.controllers')
  .controller('systemOverviewCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal) {
    // $('#mainmenuid').show();
    $scope.$on('$ionicView.enter', function(e) {
      $('#mainmenuid').show();
      $scope.$parent.$parent.inDetailpage = false;
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'System Overview';

      var lastSelectedAppBox = null;
      var alertedApplications;
      var impactedApplications;
      var wrapperDiv;
      var wrapperDivWidth = window.innerWidth;
      var wrapperDivHeight = window.innerHeight;
      var popupDiv;
      var mapSvg;
      var popupDivWidth = wrapperDivWidth;
      var currentScale = 1;
      var maxScale = 3;

      function doOnOrientationChange() {
        // console.log(window);
        switch (window.orientation) {
          case -90:
          case 90:
            wrapperDivWidth = window.innerWidth;
            wrapperDivHeight = window.innerHeight;
            break;
          default:
            // $scope.heightLandscape = {};
            wrapperDivWidth = window.innerWidth;
            wrapperDivHeight = window.innerHeight;
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);




      wrapperDiv = $('#wrapper');
      popupDiv = $('#popup');
      mapSvg = $('#map');

      //setup pan/zoom support on the SVG
      mapSvg.panzoom({
        contain: 'invert',
        minScale: 1,
        maxScale: maxScale
      });

      //add listener to update the current zoom scale
      mapSvg.on('panzoomzoom', function(e, panzoom, scale) {
        currentScale = scale
      });

      //add listener to show the popup
      mapSvg.on('panzoomend', function(e, panzoom, matrix, changed) {
        if (!changed) { //this means there was no pan/zoom, meaning this was click/touch
          var selectedAppBox = e.target.parentElement;
          var jqWrapper = $(selectedAppBox);
          if (selectedAppBox.nodeName === 'g' && jqWrapper.attr('class') && jqWrapper.attr('class').indexOf('app_box') != -1) {
            appBoxClicked(selectedAppBox, jqWrapper.attr('data-process-step'));
          }
        }
      });

      $.ajax({
        url: SERVICES_URL + '/system-overview/alerted-applications',
        type: 'GET',
        headers: {
          'uverse-dashboard-user-id': 'mv4338',
          'uverse-dashboard-application-version': '0.1',
          'uverse-dashboard-device-type': 'demo'
        },
        dataType: 'json',
        success: function(data, textStatus, jqXHR) {
          processServerData(data);
          updateMap();
          wrapperDiv.fadeIn();
        },
        error: function(jqXHR, textStatus, error) {
          alert('Status: ' + textStatus + ', Error: ' + error);
        }
      });

      function updateMap() {

        $('rect').each(function(){
          $(this).attr('style','fill:#D1D3D4');
        });
        $('path').each(function(){
          $(this).attr('style','fill:#D1D3D4');
        });
        $('circle').each(function(){
          $(this).attr('style','fill:#D1D3D4');
        });

        for (var i = 0; i < impactedApplications.length; ++i) {
          $('#' + impactedApplications[i] + ' .shape').each(function() {
            $(this).attr('style', 'fill:#FCB134')
          })
          $('#' + impactedApplications[i] + ' text').each(function() {
            $(this).attr('style', 'fill:#FFFFFF')
          })
        }

        for (var i = 0; i < alertedApplications.length; ++i) {
          $('#' + alertedApplications[i].guiId + ' .shape').each(function() {
            $(this).attr('style', 'fill:#E00000')
          })
          $('#' + alertedApplications[i].guiId + ' text').each(function() {
            $(this).attr('style', 'fill:#FFFFFF')
          })
        }
      }

      function processServerData(data) {
        alertedApplications = data.alertedApplications;
        impactedApplications = new Array();

        for (var i = 0; i < alertedApplications.length; ++i) {
          var app = alertedApplications[i];
          app.guiId = app.id.replace(/\s/g, '_');

          for (var ii = 0; ii < app.impactedApplications.length; ++ii) {
            if (app.impactedApplications[ii]) {
              impactedApplications.push(app.impactedApplications[ii].replace(/\s/g, '_'));
            }
          }
        }
      }

      function appBoxClicked(selectedAppBox, processStep) {

        addHighlight(selectedAppBox);
        if (lastSelectedAppBox) {
          removeHighlight(lastSelectedAppBox);
        }
        lastSelectedAppBox = selectedAppBox;
        lastSelectedProcessStep = processStep ? processStep : null;

        // zoom in if needed
        if (currentScale < maxScale) {
          var rect = selectedAppBox.getBoundingClientRect();
          // mapSvg.panzoom('zoom', maxScale, {
          //   animate: true,
          //   focal: {
          //     clientX: Math.round(rect.left + rect.width / 2),
          //     clientY: Math.round(rect.top + rect.height / 2)
          //   }
          // });
        }

        //check if we need to pan (if app box's center is out of the screen after zoom)
        var rect = selectedAppBox.getBoundingClientRect();

        var appBoxCenter = {
          x: Math.round(rect.left + rect.width / 2),
          y: Math.round(rect.top + rect.height / 2)
        };

        var panX = 0;
        if (appBoxCenter.x < 40) {
          panX = -1 * (appBoxCenter.x - 60);
        } else if (appBoxCenter.x > (wrapperDivWidth - 40)) {
          panX = -1 * (appBoxCenter.x - wrapperDivWidth + 60);
        }

        var panY = 0;
        if (appBoxCenter.y < 10) {
          panY = -1 * (appBoxCenter.y - 40);
        } else if (appBoxCenter.y > (wrapperDivHeight - 10)) {
          panY = -1 * (appBoxCenter.y - wrapperDivHeight + 40);
        }

        if (panX != 0 || panY != 0) {
          // open the popup after pan is done. Need to wait for pan completion in order to get the right coordinates for the selected app box
          mapSvg.on('panzoomchange', openPopupUponAppBoxTap);

          mapSvg.panzoom('pan', 0, 0, {
            relative: true
          });
        } else {
          openPopupUponAppBoxTap();
        }


      }

      function loadAppInfo(callback) {
        var appId = lastSelectedAppBox.parentElement.id;

        $.ajax({
          url: SERVICES_URL + '/system-overview/alerted-applications',
          type: 'GET',
          headers: {
            'uverse-dashboard-user-id': 'mv4338',
            'uverse-dashboard-application-version': '0.1',
            'uverse-dashboard-device-type': 'demo'
          },
          dataType: 'json',
          success: function(data, textStatus, jqXHR) {
            processServerData(data);
            updateMap();
            // wrapperDiv.fadeIn();
            $.ajax({
              url: SERVICES_URL + '/system-overview/application-info?application=' + appId.replace(/_/g, '%20') + (lastSelectedProcessStep ? '&step=' + lastSelectedProcessStep : ''),
              type: 'GET',
              headers: {
                'uverse-dashboard-user-id': 'mv4338',
                'uverse-dashboard-application-version': '0.1',
                'uverse-dashboard-device-type': 'demo'
              },
              dataType: 'json',
              success: function(data, textStatus, jqXHR) {
                var appDetails = {};
                // set application info
                appDetails.info = data.appInfo.application;

                // set process description if assigned
                if (lastSelectedProcessStep) {
                  appDetails.process = data.appInfo.process;
                }

                //add active alerts (if any)
                appDetails.messages = [];
                for (var i = 0; i < alertedApplications.length; ++i) {
                  if (alertedApplications[i].guiId == appId) {
                    for (var ii = 0; ii < alertedApplications[i].perfAlerts.length; ++ii) {
                      appDetails.messages.push(alertedApplications[i].perfAlerts[ii]);
                    }
                  }
                }

                // add historical alerts
                for (var i = 0; i < data.appInfo.historicalPerfAlerts.length; ++i) {
                  appDetails.messages.push(data.appInfo.historicalPerfAlerts[i]);
                }

                callback(appDetails);
              },
              error: function(jqXHR, textStatus, error) {
                alert('Status: ' + textStatus + ', Error: ' + error);
              }
            });
          },
          error: function(jqXHR, textStatus, error) {
            alert('Status: ' + textStatus + ', Error: ' + error);
          }
        });

      }

      var openPopupUponAppBoxTap = function() {
        //unregister the event handler that triggered openPopup
        mapSvg.off('panzoomchange', openPopupUponAppBoxTap);

        if (!lastSelectedAppBox) {
          //"close popup" event may have fired already, no need to call the back-end
          return;
        }

        loadAppInfo(function(appDetails) {
          if (!lastSelectedAppBox) {
            //"close popup" event may have fired already, so just stop processing the response from the back-end
            return;
          }

          setPopupData(appDetails);

          var selectedAppClientRect = lastSelectedAppBox.getBoundingClientRect();

          var selectedBoxCenter = Math.round(selectedAppClientRect.left + selectedAppClientRect.width / 2);

          var margin = Math.round(30 * currentScale);

          var popupLeft = 0;

          popupDiv.css('left', popupLeft).css('width', '-webkit-fill-available').fadeIn();

          //close the popup if user starts to pan/zoom the map
          mapSvg.on('panzoomstart', closePopupUponPanZoom);
        });
      }

      var closePopupUponPanZoom = function() {
        $scope.closePopup();
      }

      function updatePopup() {
        loadAppInfo(function(appDetails) {
          setPopupData(appDetails);

          var selectedAppClientRect = lastSelectedAppBox.getBoundingClientRect();

          var selectedBoxCenter = Math.round(selectedAppClientRect.left + selectedAppClientRect.width / 2);

          var margin = Math.round(30 * currentScale);

          var popupLeft = (selectedBoxCenter + popupDivWidth + margin) > wrapperDivWidth ? (selectedBoxCenter - popupDivWidth - margin) : (selectedBoxCenter + margin)

          popupDiv.animate({
            left: popupLeft
          }, 'fast');
        });
      }

      function switchToOverview() {
        $('#messages').hide();
        $('#overview').show();
        $('#messages_tab').removeClass('active');
        $('#overview_tab').addClass('active');
      }

      function switchToMessages() {
        $('#overview').hide();
        $('#messages').show();
        $('#overview_tab').removeClass('active');
        $('#messages_tab').addClass('active');
      }

      function setPopupData(appDetails) {
        $('#app_id').html(appDetails.info.id);
        $('#app_name').html(appDetails.info.name);
        $('#app_desc').html(appDetails.info.description);
        $('#overview').scrollTop(0);
        if (appDetails.process) {
          $('#process_title').show();
          $('#process_desc').show().html(appDetails.process.description);
        } else {
          $('#process_title').hide();
          $('#process_desc').hide();
        }

        switchToOverview();

        var html = '';
        for (var i = 0; i < appDetails.messages.length; ++i) {
          var msg = appDetails.messages[i];
          var msgStyle = msg.endTime ? 'historical' : 'current';
          html += '<div class="message">';
          html += '<h1 class="' + msgStyle + '">' + msg.issue + '</h1>';
          html += '<p class="' + msgStyle + '">' + msg.businessImpact + '</p>';
          html += '<h2 class="' + msgStyle + '">start time<span class="' + msgStyle + '">' + Date.parse(msg.startTime).toString('MM/dd/yyyy hh:mm tt') + '</span></h2>';
          if (msg.endTime) {
            html += '<h2 class="' + msgStyle + '">end time<span class="' + msgStyle + '">' + Date.parse(msg.endTime).toString('MM/dd/yyyy hh:mm tt') + '</span></h2>';
          }
          html += '</div>';
        }
        $('#messages').html(html);
        $('#messages').scrollTop(0);
      }

      $scope.closePopup = function() {
        popupDiv.fadeOut();
        removeHighlight(lastSelectedAppBox);
        lastSelectedAppBox = null;

        //unregister the event listener that closes the popup upon subsequent pan/zoom
        mapSvg.off('panzoomstart', closePopupUponPanZoom);
      }

      function addHighlight(appBox) {
        $(appBox).children('.shape').attr('class', 'shape selected');
      }

      function removeHighlight(appBox) {
        $(appBox).children('.shape').attr('class', 'shape');
      }

    });
  })
