// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'ngStorage'])

  .run(function($ionicPlatform, $state, LoginService, $ionicHistory, $http, $rootScope, $templateCache) {

    // Sends this header with any AJAX request
    // $http.defaults.headers.common['Access-Control-Allow-Origin'] = '*';
    // Send this header only in post requests. Specifies you are sending a JSON object
    // $http.defaults.headers.post['dataType'] = 'json'
    $ionicPlatform.registerBackButtonAction(function(event) {
      event.preventDefault();
    }, 100);
    $rootScope.perfNotification = {};
    $rootScope.touch = {};
    $ionicPlatform.ready(function() {

      push = PushNotification.init({
        android: {
         // senderID: "AIzaSyD45R2pzywXWvN6qbV_mReQjvo6lN2rQcc",
             senderID: "233967159507",
          sound: "true",
          vibrate: "true",
          forceShow: "true"
        },
        // browser: {
        //     pushServiceURL: 'http://push.api.phonegap.com/v1/push'
        // },
        ios: {
          alert: true,
          badge: true,
          sound: true
        },
        windows: {}
      });

      push.on('notification', function(data) {
        $rootScope.perfNotification = data;
        if($rootScope.perfNotification.additionalData.role === 'psg_bulletin'){
               $state.go('app.psgbulletinstatic');
            }
			else if($rootScope.perfNotification.additionalData.role === 'deployment_status'){
               $state.go('app.deploymentstatusstatic');
            }
            else if ($rootScope.perfNotification.additionalData.role === 'app_update') {
               $state.go('app.update');
            }
			else if ($rootScope.perfNotification.additionalData.role === 'dav_dashboard') {
               $state.go('app.dav',
			   {
				   'menu': 'crApproval'
			   });
            }

			else if ($rootScope.perfNotification.additionalData.role === 'heads_up') {

               $state.go('app.headsUpDtls', {
                   //Now,type is being fetched from webservice
               // 'type': "open",
                'id': $rootScope.perfNotification.additionalData.dataId
                });
            }

            else{
                $state.go('app.notification', {
                'teamname': $rootScope.perfNotification.additionalData.team,
                'application': $rootScope.perfNotification.additionalData.application,
                'palertid': $rootScope.perfNotification.additionalData.palertid,
                'current': 'true'
                });
            }
        push.finish(function(success) {
           console.log("Notification is handeled successfully");
       },
       function(error) {
           console.log("Something went wrong with notification");
       }
        );
      });

      push.on('error', function(e) {
        alert(e);
      });

      push.on('registration', function(data) {
        $rootScope.deviceToken = data.registrationId;
      });
    });


    $rootScope.$on('$viewContentLoaded', function() {
      $templateCache.removeAll();
    });

    $rootScope.$on('homeScreenQuickAction', function() {
      $state.go('app.summary');
    });

    $rootScope.$on('p0ScreenQuickAction', function() {
      $rootScope.touch = {
        'teamname': 'p0'
      };
      $state.go('app.teamP0', {
          'teamname' : $rootScope.touch.teamname
        });
    });

    $rootScope.$on('perfScreenQuickAction', function() {
      $rootScope.touch = {
        'teamname': 'amoc'
      };
      $state.go('app.teamPerf', {
          'teamname' : $rootScope.touch.teamname
        });
    });

    $rootScope.$on('iphoneStatQuickAction', function() {
      $state.go('app.iphonereportsstatic');
    });

    $ionicPlatform.ready(function() {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(false);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
      $ionicHistory.nextViewOptions({
        //disableBack: true
      });
      if (!LoginService.isAuthenticated()) {
        // console.log($state);
        // if(!LoginService.isAuthenticated()){
        //   $state.go('app.login');
        // }else{
        //   $state.go('app.currentAlerts');
        // }
        $state.go('app.login');
      }
    });
  })

  .config(function($stateProvider, $urlRouterProvider) {
    $stateProvider

      .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'templates/menu.html',
        controller: 'AppCtrl'
      })
      .state('app.accessProvisioningModal', {
              url: '/accessProvisioningModal',
              views: {
                'menuContent': {
                templateUrl: 'templates/addNewUsermodal.html'
                    }
                  }
      })
      .state('app.login', {
        url: '/login',
        views: {
          'menuContent': {
            templateUrl: 'templates/login.html'
          }
        }
      })
      .state('app.team', {
        url: '/team/:teamname',
        views: {
          'menuContent': {
            templateUrl: 'templates/team.html',
            controller: 'teamCtrl'
          }
        }
      })
      .state('app.team2', {
        url: '/team2/:teamname',
        views: {
          'menuContent': {
            templateUrl: 'templates/amocTeam.html',
            controller: 'teamCtrl'
          }
        }
      })
      .state('app.application', {
        url: '/application/:teamname/:application/:current',
        views: {
          'menuContent': {
            templateUrl: 'templates/application.html',
            controller: 'applicationCtrl'
          }
        }
      })
	  .state('app.headsUpDtls', {
        url: '/headsUpDtls/:type/:id',
        views: {
          'menuContent': {
            templateUrl: 'templates/headsUpDtls.html',
            controller: 'headsUpDtlsCtrl'
          }
        }
      })
      .state('app.userprofile', {
        url: '/userprofile/',
        views: {
          'menuContent': {
            templateUrl: 'templates/userprofile.html',
            controller: 'userProfileCtrl'
          }
        }
      })
      .state('app.palertDetail', {
        url: '/alertdetail/:teamname/:application/:palertid/:current',
        views: {
          'menuContent': {
            templateUrl: 'templates/palertDetail.html',
            controller: 'PalertCtrl'
          }
        }
      })
      .state('app.notification', {
        url: '/notification/:teamname/:application/:palertid/:current',
        views: {
          'menuContent': {
            templateUrl: 'templates/notification.html',
            controller: 'notificationCtrl'
          }
        }
      })
      .state('app.iphonereportsstatic', {
        url: '/iphonereportsstatic/',
        views: {
          'menuContent': {
            templateUrl: 'templates/slider_dashboard.html',
            controller: 'iphoneReportsStaticCtrl'
          }
        }
      })
      .state('app.imagesmenu', {
        url: '/imagesmenu/:pageHeading/:menuid/:imagepath',
        views: {
          'menuContent': {
            templateUrl: 'templates/slider_dashboard.html',
            controller: 'imageCtrl'
          }
        }
      })
      .state('app.psgbulletinstatic', {
        url: '/psgbulletinstatic/',
        views: {
          'menuContent': {
            templateUrl: 'templates/slider_dashboard.html',
            controller: 'psgBulletinStaticCtrl'
          }
        }
      })
	  .state('app.wttMenu', {
        url: '/wttMenu/',
        views: {
          'menuContent': {
            templateUrl: 'templates/wttMenu.html',
            controller: 'wttMenuCtrl'


          }
        }
      })
	  .state('app.wtt', {
        url: '/wtt/:wttName',
        views: {
          'menuContent': {
            templateUrl: 'templates/wttSlider.html',
            controller: 'wttCtrl'
          }
        }
      })
	  .state('app.deploymentstatusstatic', {
        url: '/deploymentstatusstatic/',
        views: {
          'menuContent': {
            templateUrl: 'templates/slider_dashboard.html',
            controller: 'deploymentStatusStaticCtrl'
          }
        }
      })
      .state('app.systemOverview', {
        url: '/systemOverview/',
        views: {
          'menuContent': {
            templateUrl: 'templates/systemOverview.html',
            controller: 'systemOverviewCtrl'
          }
        }
      })
      .state('app.update', {
        url: '/appUpdate/',
        views: {
          'menuContent': {
            templateUrl: 'templates/updateApp.html',
            controller: 'updateAppCtrl'
          }
        }
      })
      .state('app.graphs', {
        url: '/graphs/:graphName/:slideNum',
        views: {
          'menuContent': {
            templateUrl: 'templates/graphs.html',
            controller: 'graphsCtrl'
          }
        }
      })
      .state('app.graphsMenu', {
        url: '/graphsMenu/',
        views: {
          'menuContent': {
            templateUrl: 'templates/graphsMenu.html',
            controller: 'graphsMenuCtrl'
          }
        }
      })
      .state('app.davMenu', {
        url: '/davDashboard/',
        views: {
          'menuContent': {
            templateUrl: 'templates/davDashboard.html',
            controller: 'davDashboardCtrl'
          }
        }
      })
      .state('app.dav', {
        url: '/dav/:menu',
        views: {
          'menuContent': {
            templateUrl: 'templates/dav.html',
            controller: 'davCtrl'
          }
        }
      })
	  .state('app.paymentsMenu', {
        url: '/paymentsMenu/',
        views: {
          'menuContent': {
            templateUrl: 'templates/paymentsMenu.html',
            controller: 'paymentsMenuCtrl'
          }
        }
      })
	  .state('app.aboutMenu', {
        url: '/aboutMenu/',
        views: {
          'menuContent': {
           templateUrl: 'templates/aboutMenu.html',
		   controller: 'aboutMenuCtrl'

          }
        }
      })

	  .state('app.headsUpMenu', {
        url: '/headsUpMenu/',
        views: {
          'menuContent': {
           templateUrl: 'templates/headsUp.html',
		   controller: 'headsUpCtrl'

          }
        }
      })

      .state('app.summary', {
        url: '/summary/',
        views: {
          'menuContent': {
           templateUrl: 'templates/summary.html',
           controller: 'summaryCtrl'
          }
        }
      })
      .state('app.teamP0', {
        url: '/teamP0/:teamname',
        views: {
          'menuContent': {
            templateUrl: 'templates/team.html',
            controller: 'countCtrl'
          }
        }
      })
      .state('app.teamPerf', {
        url: '/teamPerf/:teamname',
        views: {
          'menuContent': {
            templateUrl: 'templates/amocTeam.html',
            controller: 'countCtrl'
          }
        }
      })
	  .state('app.impactView', {
        url: '/impactView/',
        views: {
          'menuContent': {
            templateUrl: 'templates/impactMeter.html',
            controller: 'impactMeterCtrl'
          }
        }
      })
      .state('app.impact', {
        url: '/impact/:lineName',
        views: {
          'menuContent': {
            templateUrl: 'templates/impactView.html',
            controller: 'impactViewCtrl'
          }
        }
      })
      .state('app.unifieddashboard', {
        url: '/unified_dashboard/',
        views: {
          'menuContent': {
            templateUrl: 'templates/unified_dashboard.html',
            controller: 'unifiedDashboardCtrl'
          }
        }
      });
    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/app/login');
  });
