angular.module('starter.controllers')
  .filter('to_trusted', ['$sce', function($sce) {
    return function(text) {
      return $sce.trustAsHtml(text);
    };
  }])
  .filter('replaceWithBRs', ['$sce', function($sce) {
    return function(text) {
      if (text != undefined) {
        return $sce.trustAsHtml(text.replace(new RegExp(String.fromCharCode(10), 'g'), "<br>"));
      }
    };
  }])
  .filter('capitalize', function() {
    return function(input) {
      if (input != 't1ps') {
        return (!!input) ? input.charAt(0).toUpperCase() + input.substr(1).toLowerCase() : '';
      } else {
        return (!!input) ? 'T1 PS' : '';
      }
    }
  })
  .filter('replaceStringP0', function() {
    return function(input) {
      if (input !== undefined) {
        input = input.replace('HEADS-UP ', '');
        // if (input.indexOf('- P0')) {
        //   var aux = input.replace(' - P0', '');
        //   if(aux.length > 18){
        //     aux = aux.substring(0, 15) + '...';
        //   }
        //   return aux;
        // }
        if (input.indexOf('Ongoing')) {
          // var aux = input.replace('Ongoing ', '');
          //  aux = aux.replace('s', '');
          //  return aux;
        }
        if (input.indexOf('HEADS-UP ')) {
          // alert("i'm in");
          var aux = input.replace('HEADS-UP ', '');
          if (aux.length > 18) {
            aux = aux.substring(0, 15) + '...';
          }
          return aux;
        }
        return input;
      }
    }
  })
  .filter('ongoingFilter', function() {
    return function(input) {
      if (input !== undefined) {
        if (input === 'Ongoing P1s') {
          var aux = input.replace('Ongoing ', '');
          aux = aux.replace('s', '');
          return aux;
        }
        return input;
      }
    }
  })
  .filter('formatDate', function() {
    return function(datereived) {
      var monthNames = [
        "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
      ];
      var dateTime = datereived.split('T');
      var ymd = dateTime[0].split('-');
      var timeparsed = dateTime[1].split(' ');
      var hourmin = timeparsed[0].split(':');
      return ymd[2] + '-' + monthNames[parseInt(ymd[1]) - 1] + '-' + (parseInt(ymd[0]) - 2000) + ' ' + hourmin[0] + ':' + hourmin[1];
    }
  })
  .filter('maxChars', function() {
    return function(input) {
      return input.substring(0, 15) + '.... ';
    }
  })
  .filter('replaceToIds', function() {
    return function(input) {
      if (input) {
        return input.replace(/\s+/g, '').replace('&', '');
      }
    }
  })
  ;
